<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
</head>

<body>
    <div class="container">
        <button class="btn btn-primary" onclick="getPost()">Get a Post</button>
        <button class="btn btn-primary" onclick="getAllPost()">Get all Post</button>
        <button class="btn btn-primary" onclick="createPost()">Create new Post</button>
        <button class="btn btn-primary" onclick="updatePost()">Update a Post</button>
        <button class="btn btn-primary" onclick="deletePost()">Delete a Post</button>
        <button class="btn btn-primary" onclick="loadPosts()">Load Posts</button>
    </div>
</body>
<script>
    const URL = 'https://jsonplaceholder.typicode.com/posts';
    callAPI = async (url, option) => {
        try {
            let response = await fetch(url, option);
            let data = await response.json();
            console.log(data);
        } catch (error) {
            console.error(error);
        }

        /*
        fetch(url, option)
            .then((response) => response.json())
            .then((json) => console.log(json))
            .catch((error) => console.error(error));*/
    }
    getPost = () => {
        callAPI(URL + '/1');
    }

    getAllPost = () => {
        callAPI(URL);
    }

    createPost = () => {
        callAPI(URL, {
            method: 'POST',
            body: JSON.stringify({
                title: 'foo',
                body: 'bar',
                userId: 1,
            }),
            headers: {
                'Content-type': 'application/json; charset=UTF-8',
            },
        });
    }

    updatePost = () => {
        callAPI(URL + '/1', {
            method: 'PUT',
            body: JSON.stringify({
                id: 1,
                title: 'foo',
                body: 'bar',
                userId: 1,
            }),
            headers: {
                'Content-type': 'application/json; charset=UTF-8',
            },
        });
    }

    deletePost = () => {
        callAPI(URL + '/1', {
            method: 'DELETE',
        });
    }

    loadPosts = async () => {

        let response1 = await fetch('https://jsonplaceholder.typicode.com/posts/1');
        let data1 = await response1.json();
        console.log(data1);

        let response2 = await fetch('https://jsonplaceholder.typicode.com/posts/2');
        let data2 = await response2.json();
        console.log(data2);  
        
        let response3 = await fetch('https://jsonplaceholder.typicode.com/posts/3');
        let data3 = await response3.json();
        console.log(data3);

        /*
        fetch('https://jsonplaceholder.typicode.com/posts/1')
            .then((response) => response.json())
            .then((json) => {
                //xong bài post 1
                console.log(json)

                //bắt đầu load post 2
                fetch('https://jsonplaceholder.typicode.com/posts/2')
                    .then((response) => response.json())
                    .then((json) => console.log(json))
                    .catch((error) => console.error(error));
            })
            .catch((error) => console.error(error));*/


    }
</script>

</html>